apiVersion: v1
kind: ConfigMap
metadata:
  name: elasticsearch
  namespace: elastic
data:
  elasticsearch.yml: |
    http.host: "0.0.0.0"
    xpack.security.enrollment.enabled: true
    xpack.security.enabled: true
    xpack.security.http.ssl.enabled: true
    xpack.security.http.ssl.key: /etc/ssl/certs/tls.key
    xpack.security.http.ssl.certificate: /etc/ssl/certs/tls.crt
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: elasticsearch
  namespace: elastic
spec:
  selector:
    matchLabels:
      app: elasticsearch
  replicas: 1
  template:
    metadata:
      labels:
        app: elasticsearch
    spec:
      containers:
      - name: elasticsearch
        image: docker.elastic.co/elasticsearch/elasticsearch:8.5.3
        imagePullPolicy: Always
        env:
        - name: ES_JAVA_OPTS
          value: -Xms512m -Xmx512m
        - name: MAX_CLAUSE_COUNT
          value: "4096"
        - name: discovery.type
          value: single-node
        - name: ELASTIC_PASSWORD
          valueFrom:
            secretKeyRef:
              key: password
              name: elastic-secret
        - name: APM_SYSTEM_PASSWORD
          valueFrom:
            secretKeyRef:
              key: password
              name: elastic-secret
        - name: KIBANA_PASSWORD
          valueFrom:
            secretKeyRef:
              key: password
              name: elastic-secret
        - name: KIBANA_SYSTEM_PASSWORD
          valueFrom:
            secretKeyRef:
              key: password
              name: elastic-secret
        - name: LOGSTASH_SYSTEM_PASSWORD
          valueFrom:
            secretKeyRef:
              key: password
              name: elastic-secret
        - name: BEATS_SYSTEM_PASSWORD
          valueFrom:
            secretKeyRef:
              key: password
              name: elastic-secret
        - name: REMOTE_MONITORING_USER_PASSWORD
          valueFrom:
            secretKeyRef:
              key: password
              name: elastic-secret
        ports:
          - containerPort: 9200
        volumeMounts:
          - name: es-data
            mountPath: "/usr/share/elasticsearch/data"
          - name: secret-volume
            mountPath: /etc/secret-volume
          - name: secret-tls
            mountPath: /etc/ssl/certs/

      volumes:
        - name: es-data
          persistentVolumeClaim:
            claimName: es-data
        - name: secret-volume
          secret:
            secretName: elastic-secret
        - name: secret-tls
          secret:
            secretName: elasticsearch-tls-secret
---
apiVersion: v1
kind: PersistentVolumeClaim
metadata:
  name: es-data
  namespace: elastic
spec:
  accessModes:
    - ReadWriteOnce
  resources:
    requests:
      storage: 100Mi
---
apiVersion: v1
kind: Service
metadata:
  name: elasticsearch
  namespace: elastic
spec:
  type: ClusterIP
  selector:
    app: elasticsearch
  ports:
    - port: 9200
      protocol: TCP
      targetPort: 9200
# ---
# apiVersion: networking.k8s.io/v1
# kind: Ingress
# metadata:
#   name: elasticsearch
#   namespace: elastic
#   annotations:
#     kubernetes.io/ingress.class: nginx
#     kubernetes.io/tls-acme: 'true'
#     nginx.ingress.kubernetes.io/ssl-passthrough: 'true'
#     nginx.ingress.kubernetes.io/backend-protocol: 'HTTPS'
# spec:
#   rules:
#     - host: elasticsearch.localdev.me
#       http:
#         paths:
#           - path: /
#             pathType: Prefix
#             backend:
#               service:
#                 name: elasticsearch
#                 port:
#                   number: 9200
#   tls:
#     - hosts:
#         - elasticsearch.localdev.me
#       secretName: elasticsearch-tls-secret